#include <pthread.h>
#include <stdio.h>
#include <string.h>
#define NUM_THREADS     5

void *PrintThread(void *threadnum)
{
  printf("Thread number %d\n", (int)threadnum);
  pthread_exit(threadnum); /* return thread number */
}

int main (int argc, char *argv[])
{
  pthread_t threads[NUM_THREADS]; /* for each thread */
  int rc, t;
  void *tv;
  for(t=0;t < NUM_THREADS;t++){
    printf("Creating thread %d\n", t + 1);
    rc = pthread_create(&threads[t], NULL, PrintThread, (void *)(t + 1));
    if (rc){
      fprintf(stderr, "pthread_create() is %s\n", strerror(rc));
      exit(-1);
    }
  }
  /* Threads are joinable so we should release the resources. 
   * This will cause the main thread to wait until all the threads
   * are complete */
  for(t=0;t < NUM_THREADS;t++){
    rc = pthread_join(threads[t], &tv);
    if (rc){
      fprintf(stderr, "pthread_exit() is %s\n", strerror(rc));
      exit(-1);
    }
    printf("Thread %d joined and returned %d\n", t+1, (int)tv);
  }
  return 0;
}
